<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/propclas.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/propclas.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_PROPCLASS__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_PROPCLASS__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2strset_8h.html">csutil/strset.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/ref_8h.html">csutil/ref.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/entity.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;physicallayer/persist.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClassList.html" title="A list of property classes.">iCelPropertyClassList</a>;
<a name="l00032"></a>00032 
<a name="l00039"></a>00039 <span class="preprocessor">#define CEL_QUERY_PROPCLASS(PcList,Interface)                               \</span>
<a name="l00040"></a>00040 <span class="preprocessor">  (celQueryPropertyClass&lt;Interface&gt; (PcList))</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="preprocessor">#define CEL_QUERY_PROPCLASS_TAG(PcList,Interface,Tag)                       \</span>
<a name="l00047"></a>00047 <span class="preprocessor">  (celQueryPropertyClassTag&lt;Interface&gt; (PcList,Tag))</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00055"></a>00055 <span class="preprocessor">#define CEL_QUERY_PROPCLASS_ENT(Ent,Interface)                              \</span>
<a name="l00056"></a>00056 <span class="preprocessor">  (celQueryPropertyClassEntity&lt;Interface&gt; (Ent))</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00062"></a>00062 <span class="preprocessor">#define CEL_QUERY_PROPCLASS_TAG_ENT(Ent,Interface,Tag)                      \</span>
<a name="l00063"></a>00063 <span class="preprocessor">  CEL_QUERY_PROPCLASS_TAG((Ent)-&gt;GetPropertyClassList(),Interface,Tag)</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#define CEL_REMOVE_PROPCLASS(PcList,Interface)                              \</span>
<a name="l00069"></a>00069 <span class="preprocessor">  ((PcList)-&gt;RemoveByInterface (scfInterfaceTraits&lt;Interface&gt;::GetID(),           \</span>
<a name="l00070"></a>00070 <span class="preprocessor">                                scfInterfaceTraits&lt;Interface&gt;::GetVersion()))</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00076"></a>00076 <span class="preprocessor">#define CEL_REMOVE_PROPCLASS_TAG(PcList,Interface,Tag)                      \</span>
<a name="l00077"></a>00077 <span class="preprocessor">  ((PcList)-&gt;RemoveByInterfaceAndTag (                                      \</span>
<a name="l00078"></a>00078 <span class="preprocessor">        scfInterfaceTraits&lt;Interface&gt;::GetID(),                                     \</span>
<a name="l00079"></a>00079 <span class="preprocessor">        scfInterfaceTraits&lt;Interface&gt;::GetVersion(), Tag))</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00084"></a>00084 <span class="preprocessor">#define CEL_REMOVE_PROPCLASS_ENT(Ent, Interface)                            \</span>
<a name="l00085"></a>00085 <span class="preprocessor">  CEL_REMOVE_PROPCLASS((Ent)-&gt;GetPropertyClassList(),Interface)</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00091"></a>00091 <span class="preprocessor">#define CEL_REMOVE_PROPCLASS_TAG_ENT(Ent,Interface,Tag)                     \</span>
<a name="l00092"></a>00092 <span class="preprocessor">  CEL_REMOVE_PROPCLASS_TAG((Ent)-&gt;GetPropertyClassList(),Interface,Tag)</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>
<a name="l00094"></a>00094 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>;
<a name="l00095"></a>00095 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>;
<a name="l00096"></a>00096 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00097"></a>00097 <span class="keyword">struct </span><a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>;
<a name="l00098"></a>00098 <span class="keyword">struct </span><a class="code" href="structiCelPropertyChangeCallback.html" title="This is a callback that is called whenever a property changes for some property class.">iCelPropertyChangeCallback</a>;
<a name="l00099"></a>00099 <span class="keyword">struct </span><a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>;
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="structiCelPropertyClass.html">00105</a> <span class="keyword">struct </span><a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107   SCF_INTERFACE (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>, 0, 0, 8);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClass.html#a90dace25f236f7940672d34dee9bb53c" title="Set the name of this property class.">SetName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClass.html#abbbc7a02c9fed6b7faaadef34a5431ca" title="Get the name of this property class.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> *<a class="code" href="structiCelPropertyClass.html#ab2c23f0735d20cf2cf7ff6932cb5388b" title="Get the associated iObject from this property class.">QueryObject</a> () = 0;
<a name="l00123"></a>00123 
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClass.html#adf05a4da86fc02ddbb9a71f954f57a22" title="Set the optional tag of this property class.">SetTag</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* tagname) = 0;
<a name="l00131"></a>00131 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClass.html#a852cb0ae0e167bd91228442bc9f2b983" title="Get the tag of this property class or return 0 if there is no tag.">GetTag</a> () <span class="keyword">const</span> = 0;
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="structiCelPropertyClass.html#aedd94ad88ef06ce28c8265dbf786c29a" title="Get the parent entity associated with this property class.">GetEntity</a> () = 0;
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClass.html#a898a39b6e49e36ed54cf3dd3966cc334" title="Set the entity for this property class.">SetEntity</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00147"></a>00147 
<a name="l00156"></a>00156   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="structiCelPropertyClass.html#af9edd0e77d8046e9b1fe05ff23a2927a" title="Save this object to a data buffer.">SaveFirstPass</a> () = 0;
<a name="l00157"></a>00157 
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#aee594ba4ddae27c61d7a7d20f526e826" title="Load this object from a data buffer.">LoadFirstPass</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00164"></a>00164 
<a name="l00168"></a>00168   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="structiCelPropertyClass.html#a8c5e094d742ab099be618f3327f4fd54" title="Save this object to a data buffer.">Save</a> () = 0;
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#adf8f476c98087ee14ab57841757c1885" title="Load this object from a data buffer.">Load</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00174"></a>00174 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ac70770cd5367393b7c5ff8948cc4e8c4" title="Add a callback which will be fired when a property changes.">AddPropertyChangeCallback</a> (<a class="code" href="structiCelPropertyChangeCallback.html" title="This is a callback that is called whenever a property changes for some property class.">iCelPropertyChangeCallback</a>* cb) = 0;
<a name="l00183"></a>00183 
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#abfe26c6414dca745816cd65b40df94a7" title="Remove a callback.">RemovePropertyChangeCallback</a> (
<a name="l00191"></a>00191         <a class="code" href="structiCelPropertyChangeCallback.html" title="This is a callback that is called whenever a property changes for some property class.">iCelPropertyChangeCallback</a>* cb) = 0;
<a name="l00192"></a>00192 
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">long</span> value) = 0;
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">float</span> value) = 0;
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">bool</span> value) = 0;
<a name="l00216"></a>00216 
<a name="l00220"></a>00220   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <span class="keywordtype">char</span>* value) = 0;
<a name="l00221"></a>00221 
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; value) = 0;
<a name="l00226"></a>00226 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; value) = 0;
<a name="l00231"></a>00231 
<a name="l00235"></a>00235   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; value) = 0;
<a name="l00236"></a>00236 
<a name="l00240"></a>00240   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID,
<a name="l00241"></a>00241         <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* value) = 0;
<a name="l00242"></a>00242 
<a name="l00246"></a>00246   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00247"></a>00247 
<a name="l00251"></a>00251   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* ibase) = 0;
<a name="l00252"></a>00252 
<a name="l00267"></a>00267   <span class="keyword">virtual</span> celDataType <a class="code" href="structiCelPropertyClass.html#a1fb38848eebfa5475c52df4ce1ff3fa1" title="Get the type of the given property or action.">GetPropertyOrActionType</a> (
<a name="l00268"></a>00268         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00269"></a>00269 
<a name="l00273"></a>00273   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a84c10b3e2da530d5e704691cf2277544" title="Return true if a property is read-only.">IsPropertyReadOnly</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00274"></a>00274 
<a name="l00278"></a>00278   <span class="keyword">virtual</span> <span class="keywordtype">long</span> <a class="code" href="structiCelPropertyClass.html#ab66ae5334a74e23fb1bf1731c28a62ef" title="Get a property as long.">GetPropertyLongByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00279"></a>00279 
<a name="l00283"></a>00283   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelPropertyClass.html#ac1d065d484f8a66f3db15b2a2c7927ff" title="Get a property as float.">GetPropertyFloatByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00284"></a>00284 
<a name="l00288"></a>00288   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a22695e69c30bc5cfd13aed6fc75dce2e" title="Get a property as bool.">GetPropertyBoolByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00289"></a>00289 
<a name="l00293"></a>00293   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClass.html#a29dfac8cc28fbb1c572868d32fad350e" title="Get a property as string.">GetPropertyStringByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00294"></a>00294 
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a104c2170cec3a98191bab896c651c052" title="Get a property as a 2D vector.">GetPropertyVectorByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; v) = 0;
<a name="l00299"></a>00299 
<a name="l00303"></a>00303   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a104c2170cec3a98191bab896c651c052" title="Get a property as a 2D vector.">GetPropertyVectorByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v) = 0;
<a name="l00304"></a>00304 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a19fd53e71b18c86882865e543fff5370" title="Get a property as a color.">GetPropertyColorByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; v) = 0;
<a name="l00309"></a>00309 
<a name="l00313"></a>00313   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiCelPropertyClass.html#a024696a20e287d373daf17dea43d3232" title="Get a property as property class.">GetPropertyPClassByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00314"></a>00314 
<a name="l00318"></a>00318   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="structiCelPropertyClass.html#af0d10f8aad18f05f8c8e8ca430d8ea69" title="Get a property as entity.">GetPropertyEntityByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00319"></a>00319 
<a name="l00323"></a>00323   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* <a class="code" href="structiCelPropertyClass.html#aff8191d0544f1b861f151985cb5f6b50" title="Get a property as iBase.">GetPropertyIBaseByID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID) = 0;
<a name="l00324"></a>00324 
<a name="l00333"></a>00333   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClass.html#a4c92554e60d83f4e69dd442360ae0956" title="Perform an action with a generic string parameter.">PerformAction</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> actionID,
<a name="l00334"></a>00334         <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params, <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret) = 0;
<a name="l00335"></a>00335 
<a name="l00339"></a>00339   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelPropertyClass.html#a9ac210ddf1bcc7b2f81fce00a86e20d3" title="Return the number of supported properties and actions.">GetPropertyAndActionCount</a> () = 0;
<a name="l00340"></a>00340 
<a name="l00344"></a>00344   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> <a class="code" href="structiCelPropertyClass.html#a2219a9b1961fcd08e790cc9b89902f8c" title="Get the ID of the given property or action.">GetPropertyOrActionID</a> (<span class="keywordtype">size_t</span> i) = 0;
<a name="l00345"></a>00345 
<a name="l00349"></a>00349   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClass.html#abf9bde220adcd2dd2234b63eb2e88b03" title="Get the description of the given property or action.">GetPropertyOrActionDescription</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>) = 0;
<a name="l00350"></a>00350 
<a name="l00358"></a>00358   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClass.html#af530504ecbc1b499e0bb230b11db1548" title="This method is called by the parent entity when there is a change in property class setting...">PropertyClassesHaveChanged</a> () = 0;
<a name="l00359"></a>00359 
<a name="l00364"></a>00364   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="structiCelPropertyClass.html#aa2c16dfc478ee3f5abfa59adb6cb48e4" title="Return the persistent data of this property class.">GetPersistentData</a> (
<a name="l00365"></a>00365         celPersistenceType persistence_type) = 0;
<a name="l00366"></a>00366 
<a name="l00378"></a>00378   <span class="keyword">virtual</span> celPersistenceResult <a class="code" href="structiCelPropertyClass.html#a460573f03fe5b2b85c0bee31c35c938a" title="Read the state of this property class from some persistent data.">SetPersistentData</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> data_time, 
<a name="l00379"></a>00379         <a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* data, celPersistenceType persistence_type) = 0;
<a name="l00380"></a>00380 };
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00386"></a><a class="code" href="structiCelPropertyClassList.html">00386</a> <span class="keyword">struct </span><a class="code" href="structiCelPropertyClassList.html" title="A list of property classes.">iCelPropertyClassList</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00387"></a>00387 {
<a name="l00388"></a>00388   SCF_INTERFACE (<a class="code" href="structiCelPropertyClassList.html" title="A list of property classes.">iCelPropertyClassList</a>, 0, 0, 2);
<a name="l00389"></a>00389 
<a name="l00393"></a>00393   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelPropertyClassList.html#add5a07bdec7d449ff1d2bd8705998758" title="Return the number of property classes in this list.">GetCount</a> () <span class="keyword">const</span> = 0;
<a name="l00394"></a>00394 
<a name="l00398"></a>00398   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiCelPropertyClassList.html#af2b7eb5f87349100599f6e801401516f" title="Return a property class by index.">Get</a> (<span class="keywordtype">size_t</span> n) <span class="keyword">const</span> = 0;
<a name="l00399"></a>00399 
<a name="l00403"></a>00403   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelPropertyClassList.html#abd2ca8b5f07f96b4269f6344dad74b9c" title="Add a property class.">Add</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* obj) = 0;
<a name="l00404"></a>00404 
<a name="l00408"></a>00408   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClassList.html#a6e22940602f49e5aa21801fa1c480b24" title="Remove a property class.">Remove</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* obj) = 0;
<a name="l00409"></a>00409 
<a name="l00413"></a>00413   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClassList.html#a6e22940602f49e5aa21801fa1c480b24" title="Remove a property class.">Remove</a> (<span class="keywordtype">size_t</span> n) = 0;
<a name="l00414"></a>00414 
<a name="l00418"></a>00418   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClassList.html#a04b51b7526f507f635f1dabfff28331f" title="Remove all property classes with given interface (ignores tag).">RemoveByInterface</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#gae3095ac94f71a5ff42374271c90222cd">scfInterfaceID</a> scf_id, <span class="keywordtype">int</span> iVersion) = 0;
<a name="l00419"></a>00419 
<a name="l00424"></a>00424   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPropertyClassList.html#a615bd044dbfaf5c3198daac7a1c91693" title="Remove all property classes with given interface and with the given tag.">RemoveByInterfaceAndTag</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#gae3095ac94f71a5ff42374271c90222cd">scfInterfaceID</a> scf_id,
<a name="l00425"></a>00425         <span class="keywordtype">int</span> iVersion, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag) = 0;
<a name="l00426"></a>00426 
<a name="l00430"></a>00430   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassList.html#ae1fc8b24f5c91e2a51a8fb6ac57eb7b5" title="Remove all property classes.">RemoveAll</a> () = 0;
<a name="l00431"></a>00431 
<a name="l00435"></a>00435   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelPropertyClassList.html#aa01a1e9377e14f2875d599f53884d3bd" title="Find a property class and return its index.">Find</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* obj) <span class="keyword">const</span> = 0;
<a name="l00436"></a>00436 
<a name="l00443"></a>00443   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiCelPropertyClassList.html#a3de03b191a798d803bd1779ea6ceaba7" title="Find a property class by name.">FindByName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *name) <span class="keyword">const</span> = 0;
<a name="l00444"></a>00444 
<a name="l00449"></a>00449   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiCelPropertyClassList.html#a96de5a7e3ab3974c2908120913465550" title="Find a property class by name and tag.">FindByNameAndTag</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *name,
<a name="l00450"></a>00450         <span class="keyword">const</span> <span class="keywordtype">char</span>* tag) <span class="keyword">const</span> = 0;
<a name="l00451"></a>00451 
<a name="l00459"></a>00459   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* <a class="code" href="structiCelPropertyClassList.html#a0df7d4095e07e62e5fe03820dec5336b" title="Find a property class by SCF interface.">FindByInterface</a> (
<a name="l00460"></a>00460         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#gae3095ac94f71a5ff42374271c90222cd">scfInterfaceID</a> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> version) <span class="keyword">const</span> = 0;
<a name="l00461"></a>00461 
<a name="l00466"></a>00466   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* <a class="code" href="structiCelPropertyClassList.html#a6159bc7c1e79b55c6ac2971c30ed8c27" title="Find a property class by SCF interface and tag.">FindByInterfaceAndTag</a> (
<a name="l00467"></a>00467         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#gae3095ac94f71a5ff42374271c90222cd">scfInterfaceID</a> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> version, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag) <span class="keyword">const</span> = 0;
<a name="l00468"></a>00468 };
<a name="l00469"></a>00469 
<a name="l00474"></a>00474 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Interface&gt;
<a name="l00475"></a>00475 <span class="keyword">inline</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> celQueryPropertyClassTag (
<a name="l00476"></a>00476   <a class="code" href="structiCelPropertyClassList.html" title="A list of property classes.">iCelPropertyClassList</a>* plist, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag)
<a name="l00477"></a>00477 {
<a name="l00478"></a>00478   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* base = plist-&gt;<a class="code" href="structiCelPropertyClassList.html#a6159bc7c1e79b55c6ac2971c30ed8c27" title="Find a property class by SCF interface and tag.">FindByInterfaceAndTag</a> (
<a name="l00479"></a>00479     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetID</a> (),
<a name="l00480"></a>00480     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetVersion</a> (),
<a name="l00481"></a>00481     tag);
<a name="l00482"></a>00482 
<a name="l00483"></a>00483   <span class="keywordflow">if</span> (base == 0) <span class="keywordflow">return</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> (0); 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   Interface* x = (Interface*)base-&gt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html#a2adc74eb0286a65f2310f221be4ddded">QueryInterface</a> (
<a name="l00486"></a>00486     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetID</a> (),
<a name="l00487"></a>00487     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetVersion</a> ());
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   base-&gt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html#a3a44d46ca155e6ab0c0179db01011bb0">DecRef</a> ();      <span class="comment">// Release our base interface.</span>
<a name="l00490"></a>00490   <span class="keywordflow">return</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> (x);
<a name="l00491"></a>00491 }
<a name="l00492"></a>00492 
<a name="l00499"></a>00499 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Interface&gt;
<a name="l00500"></a>00500 <span class="keyword">inline</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> celQueryPropertyClass (
<a name="l00501"></a>00501   <a class="code" href="structiCelPropertyClassList.html" title="A list of property classes.">iCelPropertyClassList</a>* plist)
<a name="l00502"></a>00502 {
<a name="l00503"></a>00503   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* base = plist-&gt;<a class="code" href="structiCelPropertyClassList.html#a0df7d4095e07e62e5fe03820dec5336b" title="Find a property class by SCF interface.">FindByInterface</a> (
<a name="l00504"></a>00504     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetID</a> (),
<a name="l00505"></a>00505     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetVersion</a> ());
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="keywordflow">if</span> (base == 0) <span class="keywordflow">return</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> (0); 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   Interface* x = (Interface*)base-&gt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html#a2adc74eb0286a65f2310f221be4ddded">QueryInterface</a> (
<a name="l00510"></a>00510     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetID</a> (),
<a name="l00511"></a>00511     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfInterfaceTraits.html">scfInterfaceTraits&lt;Interface&gt;::GetVersion</a> ());
<a name="l00512"></a>00512 
<a name="l00513"></a>00513   base-&gt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html#a3a44d46ca155e6ab0c0179db01011bb0">DecRef</a> ();      <span class="comment">// Release our base interface.</span>
<a name="l00514"></a>00514   <span class="keywordflow">return</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> (x);
<a name="l00515"></a>00515 }
<a name="l00516"></a>00516 
<a name="l00523"></a>00523 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Interface&gt;
<a name="l00524"></a>00524 <span class="keyword">inline</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;Interface&gt;</a> celQueryPropertyClassEntity (
<a name="l00525"></a>00525   <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity)
<a name="l00526"></a>00526 {
<a name="l00527"></a>00527   <span class="keywordflow">return</span> celQueryPropertyClass&lt;Interface&gt; (entity-&gt;<a class="code" href="structiCelEntity.html#a3ea47483cc0cea4d46537a2f1664bd13" title="Get the list of property classes.">GetPropertyClassList</a> ());
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="preprocessor">#endif // __CEL_PL_PROPCLASS__</span>
<a name="l00531"></a>00531 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
